#!/usr/bin/env node
const fs = require('fs-extra');
const path = require('path');
const { exec } = require('child_process');

module.exports = ({ projectNameSlug }) =>
  new Promise((resolve, reject) =>
    exec(`mkdir ${projectNameSlug} && cd ${projectNameSlug}`, async initErr => {
      if (initErr) {
        console.error('Could not initialize project:', initErr);
        reject(initErr);
      }
      // Copy template to project folder
      await fs
        .copy(
          path.join(__dirname, '..', 'templates', 'react-app'),
          path.join(process.cwd(), projectNameSlug),
        )
        .catch(err => {
          console.error(err);
          reject(err);
        });

      resolve();
    }),
  );
