#!/usr/bin/env node
const collectAnswers = require('./collect-answers');
const copyTemplate = require('./copy-template');
const replacePlaceholders = require('./replace-placeholders');
const installDependencies = require('./install-dependencies');

(async () => {
  const answers = await collectAnswers();

  console.log('Initializing project..');
  await copyTemplate(answers);
  console.log('Successfully copied template');

  await replacePlaceholders(answers);
  console.log('Filled in placeholders');

  console.log('Installing deps -- it might take a few minutes..');
  await installDependencies(answers);
  console.log('Dependencies installed! Happy hacking');
})();
